hdaGraph:
  imVersion: 0.3.0
  id: brussels-demo # SMO needs to create a grounded UUID for this
  version: "1.0.0"
  designer: NTUA
  hdaGraphIntent: # flavor from dropdown
  description: >-
    Brussels demo HDAG showcasing a WOT VO
  services:
    - id: vo
      deployment:
        trigger:
          auto:
            dependencies: []
        intent:
          network: OPTION1  # flavor from dropdown
          resources: OPTION1 # flavor from dropdown   
          coLocation: []
            # - id: 2
            #   groundedGraphId: UUID
          connectionPoints: [noise-reduction, image-detection]
          metrics: # list of metrics to be scraped by centralized monitoring system.
            - id: vo-metric # used for events
              metricName: MetricName #name of metric exposed to prometheus
              selector: # the target service (label). Cannot be to a pod directly, has to point to the service
                app: service_node_name 
              endpoint: # why would we need more than one??. a second metric will have an additional entry in this list 
                port: metrics # name of exposed port
                interval: 1s # scraping period of prometheus
      artifact:
        # if tag is not added, newest tag will be selected by the docker, helm and hdarctl CLIs. 
        # removing oci:// because should not customize the descriptor for implementations
        #   The OCI thing is only for helm, SMO/FRM should add it based on the target
        #   e.g., tag has a different way of adding it in helm (":1.0.0" --> "--version 1.0.0").  which would also need a custom entry in the descriptor. Better to have translation of descriptor
        ociImage: "nephele-hdar.netmode.ece.ntua.gr/brussels-demo/custom-vo:1.0.0" 
        ociConfig:
          type: VO
          implementer: WOT
        ociRun:
          name: HELM
          version: v3
        valuesOverwrite: 
          voDescriptorOverwrite: {}
          chartOverwrite: {}
    - id: noise-reduction
      deployment:
        trigger:
          event:
            condition: ANY
            events:
              - id: main-event
                source: 
                  - serviceId: vo
                    metricId: vo-metric
                condition: # This needs to be mapped to a prometheus query by the monitoring component
                  conformanceComparator: ">="
                  conformancePeriod: "5min"
                  conformanceTarget: "15"
                  graceTimes: 2
                  parameterType: "response time (ms)"
        intent:
          network: OPTION1
          coLocation: []
            # - id: 2
            #   groundedGraphId: UUID
          resources: OPTION1
          connectionPoints: [vo]
      artifact:
        ociImage: "nephele-hdar.netmode.ece.ntua.gr/brussels-demo/noise-reduction"
        ociConfig:
          type: application # Helm only allows 'library' and 'application'
          implementer: HELM
        ociRun:
          name: HELM
          version: v3
        valuesOverwrite: {}
    - id: image-detection
      deployment:
        trigger:
          auto:
            dependencies: 
              - serviceId: vo
        intent:
          network: OPTION1
          coLocation: []
            # - id: 2
            #   groundedGraphId: UUID
          resources: OPTION1
      artifact:
        ociImage: "nephele-hdar.netmode.ece.ntua.gr/brussels-demo/image-detection"
        ociConfig:
          type: application
          implementer: HELM
        ociRun:
          name: HELM
          version: v3
        valuesOverwrite: {}
